package com.ruoyi.zhdd.service;

import com.ruoyi.zhdd.domain.Plan;
import com.ruoyi.zhdd.domain.PlanTask;
import com.ruoyi.zhdd.domain.vo.PlanVo;
import com.ruoyi.zhdd.domain.bo.PlanBo;
import com.ruoyi.common.core.mybatisplus.core.IServicePlus;
import com.ruoyi.common.core.page.TableDataInfo;

import java.util.Collection;
import java.util.List;

/**
 * 预案管理Service接口
 *
 * @author xitong
 * @date 2021-09-28
 */
public interface IPlanService extends IServicePlus<Plan, PlanVo> {
	/**
	 * 查询单个
	 * @return
	 */
	PlanVo queryById(String id);

	/**
	 * 查询列表
	 */
    TableDataInfo<PlanVo> queryPageList(PlanBo bo);

	/**
	 * 查询列表
	 */
	List<PlanVo> queryList(PlanBo bo);

	/**
	 * 根据新增业务对象插入预案管理
	 * @param bo 预案管理新增业务对象
	 * @return
	 */
	Boolean insertByBo(PlanBo bo);

	/**
	 * 根据编辑业务对象修改预案管理
	 * @param bo 预案管理编辑业务对象
	 * @return
	 */
	Boolean updateByBo(PlanBo bo);

	/**
	 * 校验并删除数据
	 * @param ids 主键集合
	 * @param isValid 是否校验,true-删除前校验,false-不校验
	 * @return
	 */
	Boolean deleteWithValidByIds(Collection<String> ids, Boolean isValid);

    List<PlanTask> queryTask(String dept, Integer type, Integer level);
}
